open Ode.LowLevel;;
open Drawstuff;;

let world = dWorldCreate();;
dWorldSetGravity world ~x:0.0 ~y:0.0 ~z:(-.0.01);;
let space = dHashSpaceCreate None;;

let apple = dBodyCreate(world);;
let mass = dMassCreate();;
dMassSetZero mass;;
dMassSetSphereTotal mass ~total_mass:1.0 ~radius:0.2;;
dBodySetMass apple mass;;

let appleg = dCreateSphere None 0.2;;
dGeomSetBody appleg (Some apple);;
dGeomSetPosition appleg ~x:0.0 ~y:0.0 ~z:2.0;;

let start unit =
  begin
    dsSetViewpoint
      { Drawstuff.x = 3.0; Drawstuff.y = 0.0; Drawstuff.z = 1.0 }
      { hpr_h = (-.180.0); hpr_p = 0.0; hpr_r = 0.0; };
    dsSetSphereQuality 3
  end;;

let step n =
  begin
    dWorldStep world 0.01;
    dsSetColor { rgb_r = 1.0; rgb_g = 0.0; rgb_b = 0.0 };
    dsDrawSphere (dBodyGetPosition apple) (dBodyGetRotation apple) 0.2
  end;;

let argv = Array.make 1 "";;

(*dsSimulationLoop ~start:start ~step:step ~path:"/usr/local/share/drawstuff/textures" argv 320 240;;*)
dsSimulationLoop ~start:start ~step:step argv 320 240;;
dWorldDestroy world;;
dSpaceDestroy space;;
